#ifndef lint
#ifdef sccs
static char     sccsid[] = "HttWchar.h 1.4"
#endif
#endif
/******************************************************************

         Copyright 1990, 1991, 1992, 1993 by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Sun Microsystems, Inc.
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
Sun Microsystems, Inc. makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

Sun Microsystems Inc. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL Sun Microsystems, Inc. BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

  Author: Hideki Hiura (hhiura@Sun.COM)
	  				     Sun Microsystems, Inc.
******************************************************************/
#ifndef _HTTWCHAR_H
#define _HTTWCHAR_H
#ifndef _WCHAR_T
#define _WCHAR_T_
#endif
#ifdef _GCC_WCHAR_T
#define _GCC_WCHAR_T
#endif
#ifdef SVR4
/*
 * Assuming SVR4 always has all declaration and 
 * 4byte wchar_t representation
 */
#else /* SVR4 */
/*
 * 2byte wchar_t representation for non-POSIX platform.
 * This might be platform dependent.
 */
#ifndef SHORT_WCHAR_T
#define SHORT_WCHAR_T
typedef wchar_t wchar;
#ifndef sun
/*
 * SunOS4.x does have this declaration in <sys/stdtypes.h>
 * even without JLE/KLE/CLE/HLE. So sun system does not need
 * to typedef here.
 */
typedef unsigned short wchar_t;
#endif /* sun */
#endif /* SHORT_WCHAR_T */
#define WCHAR_SIZE	2
#define	WCHAR_CSMASK	0x8080
#define	EUCMASK		0x8080
#define	WCHAR_CS0	0x0000
#define	WCHAR_CS1	0x8080
#define	WCHAR_CS2	0x0080
#define	WCHAR_CS3	0x8000
#define	WCHAR_BYTE_OF(wc,i) (((wc&~0x8080)>>(8*(1-i)))&0x7f)
#define WCHAR_SHIFT	8
#define WCHAR_S_MASK	0xff
#define wcsetno(c)	(((c)&0x8000)?(((c)&0x80)?1:3):(((c)&0x80)?2:0))
#endif /* SVR4 */

extern wchar_t* wscpy();
extern wchar_t* wsncpy();
extern wchar_t* wscat();
extern wchar_t* wsncat();
extern wchar_t* wschr();
extern wchar_t* wsrchr();
extern wchar_t* wspbrk();
extern wchar_t* wstok();

extern int wscmp();
extern int wsncmp();
extern int wslen();
extern int wsspn();
extern int wscspn();

extern char *wstostr();

extern wchar_t *strtows();

extern wchar_t	*wsdup();
extern int	wscol();
extern double	wstod();
extern long	wstol();


#define windex		wschr
#define wrindex		wsrchr

#define watol(s)        wstol((s),(wchar_t **)0, 10)
#define watoi(s)        ((int)wstol((s),(wchar_t **)0, 10))
#define watof(s)        wstod((s),(wchar_t **)0)

#endif /*_HTTWCHAR_H */
